<?xml version="1.0" encoding="UTF-8"?>
<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  targetNamespace="http://www.cfs++.org/material"
  xmlns="http://www.cfs++.org/material"
  elementFormDefault="qualified">

  <xsd:annotation>
    <xsd:documentation xml:lang="en">
      Coupled Field Solver project CFS++
      Schema for material description of a piezo material
    </xsd:documentation>
  </xsd:annotation>


  <!-- ******************************************************************* -->
  <!--   Definition of material for piezo PDEs -->
  <!-- ******************************************************************* -->

  <xsd:complexType name="DT_MatPiezo">
    <xsd:sequence>
      <xsd:element name="piezoCoupling" type="DT_PiezoCoupling"/>
      <xsd:element name="piezoMicroData" type="DT_PiezoMicroData" minOccurs="0"/>
    </xsd:sequence>
  </xsd:complexType>

  <xsd:complexType name="DT_PiezoCoupling">
    <xsd:sequence>
      <xsd:element name="linear" type="DT_PiezoCouplingDef" minOccurs="0"/>
      <xsd:element name="nonlinear" type="DT_PiezoNonLin" minOccurs="0"/>
    </xsd:sequence>
  </xsd:complexType>

  <xsd:complexType name="DT_PiezoCouplingDef">
    <xsd:choice>
      <xsd:element name="tensor" type="DT_PiezoCouplTensor"/>
    </xsd:choice>
  </xsd:complexType>

  <!-- ******************************************************************* -->
  <!--   Definition of piezo coupling tensor                               -->
  <!-- ******************************************************************* -->
  <xsd:complexType name="DT_PiezoCouplTensor">
    <xsd:sequence>
      <xsd:element name="real">
        <xsd:simpleType>
          <xsd:restriction base="DT_TokenList">
            <xsd:maxLength value="18"/>
          </xsd:restriction>
        </xsd:simpleType>
      </xsd:element> 
      <xsd:element name="imag" minOccurs="0">
        <xsd:simpleType>
          <xsd:restriction base="DT_TokenList">
            <xsd:maxLength value="18"/>
          </xsd:restriction>
        </xsd:simpleType>
      </xsd:element> 
    </xsd:sequence>
    <xsd:attribute name="dim1" type="xsd:nonNegativeInteger" use="required"/>
    <xsd:attribute name="dim2" type="xsd:nonNegativeInteger" use="required"/>
  </xsd:complexType>
  
  <!-- ******************************************************************* -->
  <!-- Definition of piezo nonlinearity -->
  <!-- ******************************************************************* -->
  <xsd:complexType name="DT_PiezoNonLin">
    <xsd:choice>
      <xsd:element name="isotropic" type="DT_MatNonLinearity"/>
    </xsd:choice>
  </xsd:complexType>
  
  <!-- ******************************************************************* -->
  <!--   Definition of Huber-Fleck micro-piezoelectric model                                     -->
  <!-- ******************************************************************* -->
  <xsd:complexType name="DT_PiezoMicroData">
    <xsd:choice>
      <xsd:element name="HuberFleck" type="DT_HuberFleck"/>
    </xsd:choice>
  </xsd:complexType>
  
  <xsd:complexType name="DT_HuberFleck">
    <xsd:sequence>
      <xsd:element name="sponPolarization" type="xsd:double"/>
      <xsd:element name="sponStrain" type="xsd:double"/>
      <xsd:element name="Efield0" type="xsd:double"/>
      <xsd:element name="Stress0" type="xsd:double"/>
      <xsd:element name="dCouple0" type="xsd:double"/>
      <xsd:element name="rateConstant" type="xsd:double"/>
      <xsd:element name="viscoPlasticIndex" type="xsd:double"/>
      <xsd:element name="saturationIndex" type="xsd:double"/>
      <xsd:element name="scaleForceElec" type="xsd:double"/>
      <xsd:element name="scaleForceMech" type="xsd:double"/>
      <xsd:element name="scaleForceCouple" type="xsd:double"/>
      <xsd:element name="volumeFracInit" type="xsd:double"/>
      <xsd:element name="Tmean" type="xsd:double"/>
    </xsd:sequence>
  </xsd:complexType>

</xsd:schema>
